package com.neusoft.smart.pos.printer.persistent.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class PrinterInfoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer offset;

    private Integer limit;

    public PrinterInfoExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
        this.offset = null;
        this.limit = null;
    }

    public Integer getOffset() {
        return this.offset;
    }

    public void setOffset(Integer offset) {
        this.offset = offset;
    }

    public Integer getLimit() {
        return this.limit;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public PrinterInfoExample page(int offset, int limit) {
        this.offset = offset;
        this.limit = limit;
        return this;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(Integer value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(Integer value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(Integer value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(Integer value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(Integer value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<Integer> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<Integer> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(Integer value1, Integer value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(Integer value1, Integer value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andShopIdIsNull() {
            addCriterion("shop_id is null");
            return (Criteria) this;
        }

        public Criteria andShopIdIsNotNull() {
            addCriterion("shop_id is not null");
            return (Criteria) this;
        }

        public Criteria andShopIdEqualTo(Integer value) {
            addCriterion("shop_id =", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdNotEqualTo(Integer value) {
            addCriterion("shop_id <>", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdGreaterThan(Integer value) {
            addCriterion("shop_id >", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("shop_id >=", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdLessThan(Integer value) {
            addCriterion("shop_id <", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdLessThanOrEqualTo(Integer value) {
            addCriterion("shop_id <=", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdIn(List<Integer> values) {
            addCriterion("shop_id in", values, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdNotIn(List<Integer> values) {
            addCriterion("shop_id not in", values, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdBetween(Integer value1, Integer value2) {
            addCriterion("shop_id between", value1, value2, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdNotBetween(Integer value1, Integer value2) {
            addCriterion("shop_id not between", value1, value2, "shopId");
            return (Criteria) this;
        }

        public Criteria andParentIdIsNull() {
            addCriterion("parent_id is null");
            return (Criteria) this;
        }

        public Criteria andParentIdIsNotNull() {
            addCriterion("parent_id is not null");
            return (Criteria) this;
        }

        public Criteria andParentIdEqualTo(Long value) {
            addCriterion("parent_id =", value, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdNotEqualTo(Long value) {
            addCriterion("parent_id <>", value, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdGreaterThan(Long value) {
            addCriterion("parent_id >", value, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdGreaterThanOrEqualTo(Long value) {
            addCriterion("parent_id >=", value, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdLessThan(Long value) {
            addCriterion("parent_id <", value, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdLessThanOrEqualTo(Long value) {
            addCriterion("parent_id <=", value, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdIn(List<Long> values) {
            addCriterion("parent_id in", values, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdNotIn(List<Long> values) {
            addCriterion("parent_id not in", values, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdBetween(Long value1, Long value2) {
            addCriterion("parent_id between", value1, value2, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdNotBetween(Long value1, Long value2) {
            addCriterion("parent_id not between", value1, value2, "parentId");
            return (Criteria) this;
        }

        public Criteria andPrinterSnIsNull() {
            addCriterion("printer_sn is null");
            return (Criteria) this;
        }

        public Criteria andPrinterSnIsNotNull() {
            addCriterion("printer_sn is not null");
            return (Criteria) this;
        }

        public Criteria andPrinterSnEqualTo(String value) {
            addCriterion("printer_sn =", value, "printerSn");
            return (Criteria) this;
        }

        public Criteria andPrinterSnNotEqualTo(String value) {
            addCriterion("printer_sn <>", value, "printerSn");
            return (Criteria) this;
        }

        public Criteria andPrinterSnGreaterThan(String value) {
            addCriterion("printer_sn >", value, "printerSn");
            return (Criteria) this;
        }

        public Criteria andPrinterSnGreaterThanOrEqualTo(String value) {
            addCriterion("printer_sn >=", value, "printerSn");
            return (Criteria) this;
        }

        public Criteria andPrinterSnLessThan(String value) {
            addCriterion("printer_sn <", value, "printerSn");
            return (Criteria) this;
        }

        public Criteria andPrinterSnLessThanOrEqualTo(String value) {
            addCriterion("printer_sn <=", value, "printerSn");
            return (Criteria) this;
        }

        public Criteria andPrinterSnLike(String value) {
            addCriterion("printer_sn like", value, "printerSn");
            return (Criteria) this;
        }

        public Criteria andPrinterSnNotLike(String value) {
            addCriterion("printer_sn not like", value, "printerSn");
            return (Criteria) this;
        }

        public Criteria andPrinterSnIn(List<String> values) {
            addCriterion("printer_sn in", values, "printerSn");
            return (Criteria) this;
        }

        public Criteria andPrinterSnNotIn(List<String> values) {
            addCriterion("printer_sn not in", values, "printerSn");
            return (Criteria) this;
        }

        public Criteria andPrinterSnBetween(String value1, String value2) {
            addCriterion("printer_sn between", value1, value2, "printerSn");
            return (Criteria) this;
        }

        public Criteria andPrinterSnNotBetween(String value1, String value2) {
            addCriterion("printer_sn not between", value1, value2, "printerSn");
            return (Criteria) this;
        }

        public Criteria andPrinterNameIsNull() {
            addCriterion("printer_name is null");
            return (Criteria) this;
        }

        public Criteria andPrinterNameIsNotNull() {
            addCriterion("printer_name is not null");
            return (Criteria) this;
        }

        public Criteria andPrinterNameEqualTo(String value) {
            addCriterion("printer_name =", value, "printerName");
            return (Criteria) this;
        }

        public Criteria andPrinterNameNotEqualTo(String value) {
            addCriterion("printer_name <>", value, "printerName");
            return (Criteria) this;
        }

        public Criteria andPrinterNameGreaterThan(String value) {
            addCriterion("printer_name >", value, "printerName");
            return (Criteria) this;
        }

        public Criteria andPrinterNameGreaterThanOrEqualTo(String value) {
            addCriterion("printer_name >=", value, "printerName");
            return (Criteria) this;
        }

        public Criteria andPrinterNameLessThan(String value) {
            addCriterion("printer_name <", value, "printerName");
            return (Criteria) this;
        }

        public Criteria andPrinterNameLessThanOrEqualTo(String value) {
            addCriterion("printer_name <=", value, "printerName");
            return (Criteria) this;
        }

        public Criteria andPrinterNameLike(String value) {
            addCriterion("printer_name like", value, "printerName");
            return (Criteria) this;
        }

        public Criteria andPrinterNameNotLike(String value) {
            addCriterion("printer_name not like", value, "printerName");
            return (Criteria) this;
        }

        public Criteria andPrinterNameIn(List<String> values) {
            addCriterion("printer_name in", values, "printerName");
            return (Criteria) this;
        }

        public Criteria andPrinterNameNotIn(List<String> values) {
            addCriterion("printer_name not in", values, "printerName");
            return (Criteria) this;
        }

        public Criteria andPrinterNameBetween(String value1, String value2) {
            addCriterion("printer_name between", value1, value2, "printerName");
            return (Criteria) this;
        }

        public Criteria andPrinterNameNotBetween(String value1, String value2) {
            addCriterion("printer_name not between", value1, value2, "printerName");
            return (Criteria) this;
        }

        public Criteria andPrinterIpIsNull() {
            addCriterion("printer_ip is null");
            return (Criteria) this;
        }

        public Criteria andPrinterIpIsNotNull() {
            addCriterion("printer_ip is not null");
            return (Criteria) this;
        }

        public Criteria andPrinterIpEqualTo(String value) {
            addCriterion("printer_ip =", value, "printerIp");
            return (Criteria) this;
        }

        public Criteria andPrinterIpNotEqualTo(String value) {
            addCriterion("printer_ip <>", value, "printerIp");
            return (Criteria) this;
        }

        public Criteria andPrinterIpGreaterThan(String value) {
            addCriterion("printer_ip >", value, "printerIp");
            return (Criteria) this;
        }

        public Criteria andPrinterIpGreaterThanOrEqualTo(String value) {
            addCriterion("printer_ip >=", value, "printerIp");
            return (Criteria) this;
        }

        public Criteria andPrinterIpLessThan(String value) {
            addCriterion("printer_ip <", value, "printerIp");
            return (Criteria) this;
        }

        public Criteria andPrinterIpLessThanOrEqualTo(String value) {
            addCriterion("printer_ip <=", value, "printerIp");
            return (Criteria) this;
        }

        public Criteria andPrinterIpLike(String value) {
            addCriterion("printer_ip like", value, "printerIp");
            return (Criteria) this;
        }

        public Criteria andPrinterIpNotLike(String value) {
            addCriterion("printer_ip not like", value, "printerIp");
            return (Criteria) this;
        }

        public Criteria andPrinterIpIn(List<String> values) {
            addCriterion("printer_ip in", values, "printerIp");
            return (Criteria) this;
        }

        public Criteria andPrinterIpNotIn(List<String> values) {
            addCriterion("printer_ip not in", values, "printerIp");
            return (Criteria) this;
        }

        public Criteria andPrinterIpBetween(String value1, String value2) {
            addCriterion("printer_ip between", value1, value2, "printerIp");
            return (Criteria) this;
        }

        public Criteria andPrinterIpNotBetween(String value1, String value2) {
            addCriterion("printer_ip not between", value1, value2, "printerIp");
            return (Criteria) this;
        }

        public Criteria andPrinterPortIsNull() {
            addCriterion("printer_port is null");
            return (Criteria) this;
        }

        public Criteria andPrinterPortIsNotNull() {
            addCriterion("printer_port is not null");
            return (Criteria) this;
        }

        public Criteria andPrinterPortEqualTo(String value) {
            addCriterion("printer_port =", value, "printerPort");
            return (Criteria) this;
        }

        public Criteria andPrinterPortNotEqualTo(String value) {
            addCriterion("printer_port <>", value, "printerPort");
            return (Criteria) this;
        }

        public Criteria andPrinterPortGreaterThan(String value) {
            addCriterion("printer_port >", value, "printerPort");
            return (Criteria) this;
        }

        public Criteria andPrinterPortGreaterThanOrEqualTo(String value) {
            addCriterion("printer_port >=", value, "printerPort");
            return (Criteria) this;
        }

        public Criteria andPrinterPortLessThan(String value) {
            addCriterion("printer_port <", value, "printerPort");
            return (Criteria) this;
        }

        public Criteria andPrinterPortLessThanOrEqualTo(String value) {
            addCriterion("printer_port <=", value, "printerPort");
            return (Criteria) this;
        }

        public Criteria andPrinterPortLike(String value) {
            addCriterion("printer_port like", value, "printerPort");
            return (Criteria) this;
        }

        public Criteria andPrinterPortNotLike(String value) {
            addCriterion("printer_port not like", value, "printerPort");
            return (Criteria) this;
        }

        public Criteria andPrinterPortIn(List<String> values) {
            addCriterion("printer_port in", values, "printerPort");
            return (Criteria) this;
        }

        public Criteria andPrinterPortNotIn(List<String> values) {
            addCriterion("printer_port not in", values, "printerPort");
            return (Criteria) this;
        }

        public Criteria andPrinterPortBetween(String value1, String value2) {
            addCriterion("printer_port between", value1, value2, "printerPort");
            return (Criteria) this;
        }

        public Criteria andPrinterPortNotBetween(String value1, String value2) {
            addCriterion("printer_port not between", value1, value2, "printerPort");
            return (Criteria) this;
        }

        public Criteria andPrinterTypeIsNull() {
            addCriterion("printer_type is null");
            return (Criteria) this;
        }

        public Criteria andPrinterTypeIsNotNull() {
            addCriterion("printer_type is not null");
            return (Criteria) this;
        }

        public Criteria andPrinterTypeEqualTo(String value) {
            addCriterion("printer_type =", value, "printerType");
            return (Criteria) this;
        }

        public Criteria andPrinterTypeNotEqualTo(String value) {
            addCriterion("printer_type <>", value, "printerType");
            return (Criteria) this;
        }

        public Criteria andPrinterTypeGreaterThan(String value) {
            addCriterion("printer_type >", value, "printerType");
            return (Criteria) this;
        }

        public Criteria andPrinterTypeGreaterThanOrEqualTo(String value) {
            addCriterion("printer_type >=", value, "printerType");
            return (Criteria) this;
        }

        public Criteria andPrinterTypeLessThan(String value) {
            addCriterion("printer_type <", value, "printerType");
            return (Criteria) this;
        }

        public Criteria andPrinterTypeLessThanOrEqualTo(String value) {
            addCriterion("printer_type <=", value, "printerType");
            return (Criteria) this;
        }

        public Criteria andPrinterTypeLike(String value) {
            addCriterion("printer_type like", value, "printerType");
            return (Criteria) this;
        }

        public Criteria andPrinterTypeNotLike(String value) {
            addCriterion("printer_type not like", value, "printerType");
            return (Criteria) this;
        }

        public Criteria andPrinterTypeIn(List<String> values) {
            addCriterion("printer_type in", values, "printerType");
            return (Criteria) this;
        }

        public Criteria andPrinterTypeNotIn(List<String> values) {
            addCriterion("printer_type not in", values, "printerType");
            return (Criteria) this;
        }

        public Criteria andPrinterTypeBetween(String value1, String value2) {
            addCriterion("printer_type between", value1, value2, "printerType");
            return (Criteria) this;
        }

        public Criteria andPrinterTypeNotBetween(String value1, String value2) {
            addCriterion("printer_type not between", value1, value2, "printerType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeIsNull() {
            addCriterion("device_type is null");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeIsNotNull() {
            addCriterion("device_type is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeEqualTo(String value) {
            addCriterion("device_type =", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeNotEqualTo(String value) {
            addCriterion("device_type <>", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeGreaterThan(String value) {
            addCriterion("device_type >", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeGreaterThanOrEqualTo(String value) {
            addCriterion("device_type >=", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeLessThan(String value) {
            addCriterion("device_type <", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeLessThanOrEqualTo(String value) {
            addCriterion("device_type <=", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeLike(String value) {
            addCriterion("device_type like", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeNotLike(String value) {
            addCriterion("device_type not like", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeIn(List<String> values) {
            addCriterion("device_type in", values, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeNotIn(List<String> values) {
            addCriterion("device_type not in", values, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeBetween(String value1, String value2) {
            addCriterion("device_type between", value1, value2, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeNotBetween(String value1, String value2) {
            addCriterion("device_type not between", value1, value2, "deviceType");
            return (Criteria) this;
        }

        public Criteria andPrinterStatusIsNull() {
            addCriterion("printer_status is null");
            return (Criteria) this;
        }

        public Criteria andPrinterStatusIsNotNull() {
            addCriterion("printer_status is not null");
            return (Criteria) this;
        }

        public Criteria andPrinterStatusEqualTo(String value) {
            addCriterion("printer_status =", value, "printerStatus");
            return (Criteria) this;
        }

        public Criteria andPrinterStatusNotEqualTo(String value) {
            addCriterion("printer_status <>", value, "printerStatus");
            return (Criteria) this;
        }

        public Criteria andPrinterStatusGreaterThan(String value) {
            addCriterion("printer_status >", value, "printerStatus");
            return (Criteria) this;
        }

        public Criteria andPrinterStatusGreaterThanOrEqualTo(String value) {
            addCriterion("printer_status >=", value, "printerStatus");
            return (Criteria) this;
        }

        public Criteria andPrinterStatusLessThan(String value) {
            addCriterion("printer_status <", value, "printerStatus");
            return (Criteria) this;
        }

        public Criteria andPrinterStatusLessThanOrEqualTo(String value) {
            addCriterion("printer_status <=", value, "printerStatus");
            return (Criteria) this;
        }

        public Criteria andPrinterStatusLike(String value) {
            addCriterion("printer_status like", value, "printerStatus");
            return (Criteria) this;
        }

        public Criteria andPrinterStatusNotLike(String value) {
            addCriterion("printer_status not like", value, "printerStatus");
            return (Criteria) this;
        }

        public Criteria andPrinterStatusIn(List<String> values) {
            addCriterion("printer_status in", values, "printerStatus");
            return (Criteria) this;
        }

        public Criteria andPrinterStatusNotIn(List<String> values) {
            addCriterion("printer_status not in", values, "printerStatus");
            return (Criteria) this;
        }

        public Criteria andPrinterStatusBetween(String value1, String value2) {
            addCriterion("printer_status between", value1, value2, "printerStatus");
            return (Criteria) this;
        }

        public Criteria andPrinterStatusNotBetween(String value1, String value2) {
            addCriterion("printer_status not between", value1, value2, "printerStatus");
            return (Criteria) this;
        }

        public Criteria andVersionIsNull() {
            addCriterion("version is null");
            return (Criteria) this;
        }

        public Criteria andVersionIsNotNull() {
            addCriterion("version is not null");
            return (Criteria) this;
        }

        public Criteria andVersionEqualTo(Integer value) {
            addCriterion("version =", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotEqualTo(Integer value) {
            addCriterion("version <>", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionGreaterThan(Integer value) {
            addCriterion("version >", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionGreaterThanOrEqualTo(Integer value) {
            addCriterion("version >=", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionLessThan(Integer value) {
            addCriterion("version <", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionLessThanOrEqualTo(Integer value) {
            addCriterion("version <=", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionIn(List<Integer> values) {
            addCriterion("version in", values, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotIn(List<Integer> values) {
            addCriterion("version not in", values, "version");
            return (Criteria) this;
        }

        public Criteria andVersionBetween(Integer value1, Integer value2) {
            addCriterion("version between", value1, value2, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotBetween(Integer value1, Integer value2) {
            addCriterion("version not between", value1, value2, "version");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(String value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(String value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(String value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(String value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(String value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(String value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLike(String value) {
            addCriterion("created_by like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotLike(String value) {
            addCriterion("created_by not like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<String> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<String> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(String value1, String value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(String value1, String value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIsNull() {
            addCriterion("updated_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIsNotNull() {
            addCriterion("updated_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedByEqualTo(String value) {
            addCriterion("updated_by =", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotEqualTo(String value) {
            addCriterion("updated_by <>", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByGreaterThan(String value) {
            addCriterion("updated_by >", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByGreaterThanOrEqualTo(String value) {
            addCriterion("updated_by >=", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLessThan(String value) {
            addCriterion("updated_by <", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLessThanOrEqualTo(String value) {
            addCriterion("updated_by <=", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLike(String value) {
            addCriterion("updated_by like", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotLike(String value) {
            addCriterion("updated_by not like", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIn(List<String> values) {
            addCriterion("updated_by in", values, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotIn(List<String> values) {
            addCriterion("updated_by not in", values, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByBetween(String value1, String value2) {
            addCriterion("updated_by between", value1, value2, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotBetween(String value1, String value2) {
            addCriterion("updated_by not between", value1, value2, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNull() {
            addCriterion("updated_at is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNotNull() {
            addCriterion("updated_at is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtEqualTo(Date value) {
            addCriterion("updated_at =", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotEqualTo(Date value) {
            addCriterion("updated_at <>", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThan(Date value) {
            addCriterion("updated_at >", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("updated_at >=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThan(Date value) {
            addCriterion("updated_at <", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThanOrEqualTo(Date value) {
            addCriterion("updated_at <=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIn(List<Date> values) {
            addCriterion("updated_at in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotIn(List<Date> values) {
            addCriterion("updated_at not in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtBetween(Date value1, Date value2) {
            addCriterion("updated_at between", value1, value2, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotBetween(Date value1, Date value2) {
            addCriterion("updated_at not between", value1, value2, "updatedAt");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}